unit _gs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TGleichung = record
   z1, z2, z3, z4:integer;
  end;
  TForm1 = class(TForm)
    Button1: TButton;
    _out: TMemo;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    GroupBox2: TGroupBox;
    Button2: TButton;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  gg1,gg2,gg3: TGleichung;
implementation

{$R *.dfm}

function isNumber(s:string):boolean;
var c:integer;
const nums:string = '-0123456789';
begin
 if (length(s) > 0) then result:=true else result:=false;
 for c:=1 to length(s) do if (Pos(copy(s,c,1),nums) = 0) then result:=false;
end;

procedure OutPut(name:string; g1: TGleichung);
begin
Form1._out.lines.add(name+':'+inttostr(g1.z1)+'x + '+inttostr(g1.z2)+'y + '+inttostr(g1.z3)+'z = '+inttostr(g1.z4));
end;

function Subtrahieren(g1,g2: TGleichung):TGleichung;
begin
result.z1:=g1.z1 - g2.z1;
result.z2:=g1.z2 - g2.z2;
result.z3:=g1.z3 - g2.z3;
result.z4:=g1.z4 - g2.z4;
end;

function KickFirst(g1,g2: TGleichung):TGleichung;
var t1,t2:TGleichung;
begin
// Gleichung 1
t1.z1:=g1.z1 * g2.z1;
t1.z2:=g1.z2 * g2.z1;
t1.z3:=g1.z3 * g2.z1;
t1.z4:=g1.z4 * g2.z1;
// Gleichung 2
t2.z1:=g2.z1 * g1.z1;
t2.z2:=g2.z2 * g1.z1;
t2.z3:=g2.z3 * g1.z1;
t2.z4:=g2.z4 * g1.z1;
// Subtrahieren der gleichung mit der kleineren 2. zahl
if (t1.z2 < t2.z2) then
 result:=Subtrahieren(t2,t1)
else result:=Subtrahieren(t1,t2);
end;

function KickSecond(g1,g2: TGleichung):TGleichung;
var t1,t2:TGleichung;
begin
// Gleichung 1
t1.z2:=g1.z2 * g2.z2;
t1.z3:=g1.z3 * g2.z2;
t1.z4:=g1.z4 * g2.z2;
// Gleichung 2
t2.z2:=g2.z2 * g1.z2;
t2.z3:=g2.z3 * g1.z2;
t2.z4:=g2.z4 * g1.z2;
// Subtrahieren der gleichung mit der kleineren 3. zahl
if (t1.z3 < t2.z3) then
 result:=Subtrahieren(t2,t1)
else result:=Subtrahieren(t1,t2);
end;

procedure TForm1.Button1Click(Sender: TObject);
var _g1,_g2,_g3:TGleichung;
function _n(num:integer):integer;
begin
result:=1;
if (FindComponent('Edit'+IntToStr(num)) <> nil) then
 if (isNumber(TEdit(FindComponent('Edit'+IntToStr(num))).Text)) then
  result:=StrToInt(TEdit(FindComponent('Edit'+IntToStr(num))).Text);
end;
begin
gg1.z1:=_n(1);
gg1.z2:=_n(2);
gg1.z3:=_n(3);
gg1.z4:=_n(10);

gg2.z1:=_n(6);
gg2.z2:=_n(5);
gg2.z3:=_n(4);
gg2.z4:=_n(11);

gg3.z1:=_n(9);
gg3.z2:=_n(8);
gg3.z3:=_n(7);
gg3.z4:=_n(12);

_out.Clear;
OutPut('I',gg1);
OutPut('II',gg2);
OutPut('III',gg3);

_g1:=KickFirst(gg1,gg2);
_g2:=KickFirst(gg2,gg3);
_g3:=KickSecond(_g1,_g2);
try
_g3.z4:=_g3.z4 div _g3.z3;
_g2.z4:=_g2.z4-(_g2.z3 * _g3.z4);
_g2.z4:=_g2.z4 div _g2.z2;
gg1.z4:=gg1.z4-(gg1.z3 * _g3.z4)-(gg1.z2 * _g2.z4);
gg1.z4:=gg1.z4 div gg1.z1;
_out.Lines.Add('|L = {('+IntTostr(gg1.z4)+'/'+IntToStr(_g2.z4)+'/'+IntToStr(_g3.z4)+')}');
except
 _out.Lines.Add('Fehler beim berechnen');
end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var c:integer;
begin
for c:=1 to 12 do
 TEdit(FindComponent('Edit'+IntToStr(c))).Text:='1';
end;

end.
